//This plays Glediator files from the SD card called animX.dat where X
//is any number

int loopcounter  =  1;
int numberoffiles = 21;
String filename = "anim";
String filetype = ".dat";
boolean locked = false;
const uint8_t kMatrixWidth  = 12;
const uint8_t kMatrixHeight = 12;

boolean SDRunning = true;
File fxdata;

void SDinit() {
  pinMode(10, OUTPUT); // CS/SS pin as output for SD library to work.
  digitalWrite(10, HIGH); // workaround for sdcard failed error...


  // test file open
  fxdata = SD.open("anim1.dat");  // read only
  if (fxdata)
  {
    Serial.println("file open ok");
    fxdata.close();
  }
}

int serialGlediator ()
{
  while (!Serial.available()) {}
  return Serial.read();
}


void runSDCard() {
  SDinit();
  SDRunning = true;

  while (SDRunning) {
    
    Serial.println(loopcounter);
    // put SD card code here
    String file = filename + loopcounter + filetype;
    fxdata = SD.open(file);  // read only
    if (fxdata)
    {
      Serial.println("file open ok");
    }

    while (fxdata.available())
    {
      int mappedValue = map(analogRead(brightnessInPin), 0, 1023, 0, MAX_BRIGHTNESS);
      //Serial.println(analogRead(brightnessInPin));
      fxdata.readBytes((char*)leds, NUM_LEDS * 3);
      //This is the line order switching code I added in. It is pretty basic but seems to work ok
      for (int currentrow = 0; currentrow < kMatrixHeight  ;  currentrow++)
      {
        //even
        int rowstart = currentrow * kMatrixWidth; //calculate the row start position in the snake
        if ( (currentrow % 2) == 0) { //only work on even rows
          for (int i = 0, j = kMatrixWidth - 1; i < kMatrixWidth / 2; i++, j--)
          {
            CRGB temp = leds[i + rowstart]; //take temporary value from start of row
            leds[i + rowstart] = leds[j + rowstart]; // put value from end of row at start
            leds[j + rowstart] = temp; // put temporary value at the end of the row
          }
        }
      }
      int mappedValuesd = map(analogRead(brightnessInPin), 0, 1023, 0, MAX_BRIGHTNESS);
      FastLED.setBrightness(constrain(mappedValuesd, MIN_BRIGHTNESS, MAX_BRIGHTNESS));
      FastLED.show();
      delay(50); // set the speed of the animation. 20 is appx ~ 500k bauds
      //Serial.println("OK");
      //Read buttons

      readInput();
      if (curControl == BTN_EXIT) {
        Serial.println("EXIT");
        SDRunning = false;
        break;
      }
      else if (curControl == BTN_START) {
        locked = 1 - locked;
        if (locked == 1) {
          FastLED.setBrightness(255);
          FastLED.show();
          Serial.println("Locked");
          delay(500);
        }
        else if (locked == 0) {
          FastLED.setBrightness(10);
          FastLED.show();
          Serial.println("Unlocked");
          delay(500);
        }
      }
      else if (curControl == BTN_LEFT) {
        Serial.println("Previous Anim");
        locked = false;
        loopcounter = loopcounter - 2;
        break;
      }

      if (curControl == BTN_RIGHT) {
        Serial.println("Next Anim");
        locked = false;
        break;
      }

    }




    /*   setTablePixel (x, y, leds);
        FastLED.setBrightness(constrain(mappedValue, MIN_BRIGHTNESS, MAX_BRIGHTNESS));
        showPixels();
    */
    fxdata.close();
    if (locked == true) {
      loopcounter = loopcounter;
    } else {
      loopcounter = loopcounter + 1;
    }
    if (loopcounter == numberoffiles) {
      loopcounter = 0;
    }
  }
  fadeOut();
}

